/*
 * このソースコードは blanco Frameworkによって自動生成されています。
 * Apache Antタスク [BlancoXliff2Tmx]のクラス
 */
package blanco.xliff2tmx.task;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

import blanco.xliff2tmx.task.valueobject.BlancoXliff2TmxProcessInput;

/**
 * Apache Antタスク [BlancoXliff2Tmx]のクラス。
 *
 * OASIS XLIFF から TMX を生成するためのAntTaskです。<br>
 * このクラスでは、Apache Antタスクで一般的に必要なチェックなどのコーディングを肩代わりします。
 * 実際の処理は パッケージ[blanco.xliff2tmx.task]にBlancoXliff2TmxBatchProcessクラスを作成して記述してください。<br>
 * <br>
 * Antタスクへの組み込み例<br>
 * <pre>
 * &lt;taskdef name=&quot;blancoxliff2tmx&quot; classname=&quot;blanco.xliff2tmx.task.BlancoXliff2TmxTask">
 *     &lt;classpath&gt;
 *         &lt;fileset dir=&quot;lib&quot; includes=&quot;*.jar&quot; /&gt;
 *         &lt;fileset dir=&quot;lib.ant&quot; includes=&quot;*.jar&quot; /&gt;
 *     &lt;/classpath&gt;
 * &lt;/taskdef&gt;
 * </pre>
 */
public class BlancoXliff2TmxTask extends Task {
    /**
     * OASIS XLIFF から TMX を生成するためのAntTaskです。
     */
    protected BlancoXliff2TmxProcessInput fInput = new BlancoXliff2TmxProcessInput();

    /**
     * OASIS XLIFF から TMX を生成するためのAntTaskです。
     */
    protected boolean fIsFieldSourcedirProcessed = false;

    /**
     * OASIS XLIFF から TMX を生成するためのAntTaskです。
     */
    protected boolean fIsFieldTargetdirProcessed = false;

    /**
     * OASIS XLIFF から TMX を生成するためのAntTaskです。
     */
    protected boolean fIsFieldTargetfileProcessed = false;

    /**
     * OASIS XLIFF から TMX を生成するためのAntTaskです。
     */
    protected boolean fIsFieldCheckalttranspleiadesProcessed = false;

    /**
     * verboseモードで動作させるかどうか。
     *
     * @param arg verboseモードで動作させるかどうか。
     */
    public void setVerbose(final boolean arg) {
        fInput.setVerbose(arg);
    }

    /**
     * verboseモードで動作させるかどうか。
     *
     * @return verboseモードで動作させるかどうか。
     */
    public boolean getVerbose() {
        return fInput.getVerbose();
    }

    /**
     * Antタスクの[sourcedir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 1<br>
     * 入力となる OASIS XLIFF ファイルが格納されているディレクトリ。<br>
     *
     * @param arg セットしたい値
     */
    public void setSourcedir(final String arg) {
        fInput.setSourcedir(arg);
        fIsFieldSourcedirProcessed = true;
    }

    /**
     * Antタスクの[sourcedir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 1<br>
     * 入力となる OASIS XLIFF ファイルが格納されているディレクトリ。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getSourcedir() {
        return fInput.getSourcedir();
    }

    /**
     * Antタスクの[targetdir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 2<br>
     * 出力となる TMX ファイルが格納されるディレクトリ。targetfile と排他的に利用。<br>
     *
     * @param arg セットしたい値
     */
    public void setTargetdir(final String arg) {
        fInput.setTargetdir(arg);
        fIsFieldTargetdirProcessed = true;
    }

    /**
     * Antタスクの[targetdir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 2<br>
     * 出力となる TMX ファイルが格納されるディレクトリ。targetfile と排他的に利用。<br>
     *
     * @return このフィールドの値
     */
    public String getTargetdir() {
        return fInput.getTargetdir();
    }

    /**
     * Antタスクの[targetfile]アトリビュートのセッターメソッド。
     *
     * 項目番号: 3<br>
     * 出力となる TMX ファイルのファイル名。targetdir と排他的に利用。<br>
     *
     * @param arg セットしたい値
     */
    public void setTargetfile(final String arg) {
        fInput.setTargetfile(arg);
        fIsFieldTargetfileProcessed = true;
    }

    /**
     * Antタスクの[targetfile]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 3<br>
     * 出力となる TMX ファイルのファイル名。targetdir と排他的に利用。<br>
     *
     * @return このフィールドの値
     */
    public String getTargetfile() {
        return fInput.getTargetfile();
    }

    /**
     * Antタスクの[checkalttranspleiades]アトリビュートのセッターメソッド。
     *
     * 項目番号: 4<br>
     * alt-transの Pleiades 訳と一致する場合にのみTMXを作成するかどうか。<br>
     *
     * @param arg セットしたい値
     */
    public void setCheckalttranspleiades(final boolean arg) {
        fInput.setCheckalttranspleiades(arg);
        fIsFieldCheckalttranspleiadesProcessed = true;
    }

    /**
     * Antタスクの[checkalttranspleiades]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 4<br>
     * alt-transの Pleiades 訳と一致する場合にのみTMXを作成するかどうか。<br>
     * デフォルト値[false]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public boolean getCheckalttranspleiades() {
        return fInput.getCheckalttranspleiades();
    }

    /**
     * Antタスクのメイン処理。Apache Antから このメソッドが呼び出されます。
     *
     * @throws BuildException タスクとしての例外が発生した場合。
     */
    public final void execute() throws BuildException {
        System.out.println("BlancoXliff2TmxTask begin.");

        // 項目番号[1]、アトリビュート[sourcedir]は必須入力です。入力チェックを行います。
        if (fIsFieldSourcedirProcessed == false) {
            throw new BuildException("必須アトリビュート[sourcedir]が設定されていません。処理を中断します。");
        }

        if (getVerbose()) {
            System.out.println("- verbose:[true]");
            System.out.println("- sourcedir:[" + getSourcedir() + "]");
            System.out.println("- targetdir:[" + getTargetdir() + "]");
            System.out.println("- targetfile:[" + getTargetfile() + "]");
            System.out.println("- checkalttranspleiades:[" + getCheckalttranspleiades() + "]");
        }

        try {
            // 実際のAntタスクの主処理を実行します。
            // この箇所でコンパイルエラーが発生する場合、BlancoXliff2TmxProcessインタフェースを実装して blanco.xliff2tmx.taskパッケージに BlancoXliff2TmxProcessImplクラスを作成することにより解決できる場合があります。
            final BlancoXliff2TmxProcess proc = new BlancoXliff2TmxProcessImpl();
            if (proc.execute(fInput) != BlancoXliff2TmxBatchProcess.END_SUCCESS) {
                throw new BuildException("タスクは異常終了しました。");
            }
        } catch (IllegalArgumentException e) {
            if (getVerbose()) {
                e.printStackTrace();
            }
            throw new BuildException(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中に例外が発生しました。処理を中断します。" + e.toString());
        } catch (Error e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中にエラーが発生しました。処理を中断します。" + e.toString());
        }
    }
}
